import {delimiter} from "path";

// Load config from specified path or default + swaf/config (default defaults)
process.env['NODE_CONFIG_DIR'] =
    __dirname + '/../../node_modules/swaf/config/'
    + delimiter
    + (process.env['NODE_CONFIG_DIR'] || __dirname + '/../../config/');

import {log} from "swaf/Logger";
import App from "./App";
import config from "config";

(async () => {
    log.debug('Config path:', process.env['NODE_CONFIG_DIR']);

    const app = new App(config.get<string>('listen_addr'), config.get<number>('port'));
    await app.start();
})().catch(err => {
    log.error(err);
});
